#!/bin/sh
#######################################################################################
# Rep2Thumb 0.5                                       
# Script de cration d'une galerie pour PhpWebGallery  
#	Paramtre 1 : repertoire des photos
#	Paramtre 2 : nom de la galerie
#	Paramtre 3 : nombre de rcursivit de lecture du rpertoire photos source
#       Paramtre 4 : choix de la copie des photos hautes rsolutions ou non (o/n)
#
#                                                            
# Gothico (c) 2007                                 
# gothico@free.fr                                      
#
#
# Contributeur :
# Madsen C. 25/01/2006
#######################################################################################


## CONFIGURATION ###########################################

# Chemin complet des galeries du site (sans le '/')
CHEMIN_WEBGALLERY="/var/www/html/fotos/webgallery/galleries"

# Nom du rpertoire  crer pour les miniatures
# ("thumbnail" par dfaut dans phpwebgallery)
NOM_REP_THUMB="thumbnail"

# Nom du rpertoire  crer pour les miniatures
# ("pwg_high" par dfaut dans phpwebgallery)
NOM_REP_HIGH="pwg_high"

# Nom du prfixe des miniatures
# ("TN-" par dfaut dans phpwebgallery)
PRE_TN="TN-"

# L'extension des images (indpendant de la casse)
EXTENSION="jpg"

# Taille des photos miniatures
TAILLE_THUMB="128x96"

# Taille des photos  afficher dans phpwebgallery
TAILLE_PHOTOS="640x480"

############
# Texte de copyright (si vous ne souhaitez pas de copyright, laissez cette variable vide)
TXT_COPYRIGHT=""

# Police du copyright
FONT_COPYRIGHT="comicbd.ttf"

# Chemin complet de la police (obligatoirement prsent  la racine du script si non renseign)
CHEMIN_FONT_COPYRIGHT=""
############################################################

# Construction chemin FONT si non renseign 
if [ -z "$CHEMIN_FONT_COPYRIGHT" ]
then
	CHEMIN_FONT_COPYRIGHT=`pwd`
fi
	
# Demande le chemin des photos sources s'il n'a pas t pass en paramtre
if [ -z "$1" ]
then
	while [ -z $chemin ]
	do
		echo -n "Entrez le chemin complet  partir du script ou de la racine en commenant par '/' : "	
		read chemin
	done
       cd $chemin
else
       cd "$1"
fi

# Demande le nom de la galerie s'il n'a pas t pass en paramtre
if [ -z "$2" ]
then
	echo "Choisissez le nom de votre galerie."
	echo "Pour l'ajouter en tant que sous-catgorie, procdez comme suit 'Galerie_exitante/Nouvelle_sous_categorie'."
	while [ -z $nom_gallery ]
	do
		echo -n "Entrez le nom de la galerie sans '/'  la fin : "	
		read nom_gallery
	done
else
	nom_gallery=$2
fi

# Demande la rcursivit si elle n'a pas t passe en paramtre
if [ -z "$3" ]
then
	echo "Souhaitez-vous un traitement rcursif des dossiers ?"
	echo "ATTENTION : toutes les images trouves seront places dans la mme galerie sans arborescence!"
	echo "(pour conserver une arborescence, faites le en plusieurs fois)"

	while [ -z $nb_recursif ]
	do
		echo -n "Si oui, donnez un chiffre de profondeur maximale entre 2 et 5, sinon entrez 1 : "
		read nb_recursif
	done
else 
	nb_recursif=$3
fi

# Test du nombre de rcursivit, pas plus de 5 pour plus de scurit
# (si vous avez une autre solutions plus simple pour faire ce test, je suis preneur)
case $nb_recursif in
        1) ;; 2) ;; 3) ;; 4) ;; 5) ;;
        *) nb_recursif=1; echo " => /!\\ Erreur de saisie : la valeur par dfaut 1 sera utilise. /!\\" ;;
esac

# Demande pour la gnration des hautes dfinitions si cela n'a pas t passe en paramtre
if [ -z "$4" ]
then
        while ([ -z $high ] || ([ "$high" != "o" ] && [ "$high" != "y" ] && [ "$high" != "n" ]))
        do
                echo -n "Souhaitez-vous la copie des photos hautes dfinitions? (o/n) : "
                read high
        done
else
	if ( [ "$4" != "o" ] && [ "$4" != "y" ] && [ "$4" != "n" ] )
	then
        	while ([ -z $high ] || ([ "$high" != "o" ] && [ "$high" != "y" ] && [ "$high" != "n" ]))
	        do
	                echo -n "ERREUR DE SAISIE DU PARAMETRE : Souhaitez-vous la copie des photos hautes dfinitions? (o/n) : "
	                read high
	        done
	else
		high=$4
	fi
fi


# Cration rpertoire
echo "Cration des rpertoires..."
mkdir $CHEMIN_WEBGALLERY/$nom_gallery 2> err_Rep2Thumb
mkdir $CHEMIN_WEBGALLERY/$nom_gallery/$NOM_REP_THUMB 2> err_Rep2Thumb
if ( [ "$high" = "o" ] || [ "$high" = "y" ] )
then
	mkdir $CHEMIN_WEBGALLERY/$nom_gallery/$NOM_REP_HIGH
fi

# Test du rpertoire, proposition d'arreter le script s'il existe
if [ -s err_Rep2Thumb ]
then
	echo "INFORMATION : Apparemment, la galerie existe dj."
	echo "Si les noms des photos sont diffrents, les photos seront simplement ajoutes  cette galerie."
	
	while ([ -z $continu ] || ([ "$continu" != "o" ] && [ "$continu" != "y" ] && [ "$continu" != "n" ]))
	do
		echo -n "Souhaitez-vous continuer? (o/n) : "
		read continu
	done

fi

# Suppression des erreurs
rm -f err_Rep2Thumb

# Arret du script si rponse = non
if [ "$continu" = "n" ]
then
	echo "Arret du script volontaire."
	exit
fi

# Slection et copie des fichiers
echo "Copie des fichiers..."
find $rep_source -maxdepth $nb_recursif -iname "*.$EXTENSION" -exec cp {} $CHEMIN_WEBGALLERY/$nom_gallery \;

# On va dans le rpertoire en question (la galerie, cela simplifie les lignes de commande)
cd $CHEMIN_WEBGALLERY/$nom_gallery

# On renomme si besoins est (enlve les caractres spciaux, si j'en ai oubli, dites le moi)
echo "Renomme si besoin..."
ls -b | while read i ; do mv -f "$i" `echo "$i" | sed -e s/\ /_/g | sed -e s/\'//g | sed -e s/\"//g | sed -e s/\,//g | sed -e s/\;//g | sed -e s///g | sed -e s/!//g | sed -e s//c/g | sed -e s//u/g | sed -e s//e/g | sed -e s//a/g | sed -e s//i/g | sed -e s//i/g | sed -e s//o/g | sed -e s//o/g | sed -e s//u/g | sed -e s//u/g | sed -e s//e/g | sed -e s//e/g | sed -e s/~//g | sed -e s//2/g | sed -e s/\&//g | sed -e s/\#//g | sed -e s/\(//g | sed -e s/\)//g | sed -e s//e/g | sed -e s///g | sed -e s/=//g | sed -e s/\{//g | sed -e s/\}//g | sed -e s/+//g` ; done &> /dev/null

# On slectionne toutes les photos dj copies de la galerie pour le traitement
all_jpg_files_new=`find . -maxdepth 1 -iname "*.$EXTENSION"`

# Copie des photos hautes dfinitions si option choisie
if ( [ "$high" = "o" ] || [ "$high" = "y" ] )
then
	echo "Copie des photos hautes dfinitions..."
	for i in $all_jpg_files_new; do convert -quality 90 -font $CHEMIN_FONT_COPYRIGHT/$FONT_COPYRIGHT -fill grey -pointsize 55 -gravity SouthWest -draw "text 50,40 '$TXT_COPYRIGHT'" $i $NOM_REP_HIGH/`basename $i`; echo -n "."; done
	echo ""
fi

# Redimensionnement pour les miniatures dans le rpertoire configur
echo "Redimensionnement thumbnail..."
for i in $all_jpg_files_new; do convert -thumbnail $TAILLE_THUMB $i $NOM_REP_THUMB/$PRE_TN`basename $i`; echo -n "."; done
echo ""

# Redimentionnement des originales
echo "Redimensionnement photos..."
for i in $all_jpg_files_new; do convert -quality 90 -resize $TAILLE_PHOTOS -font $CHEMIN_FONT_COPYRIGHT/$FONT_COPYRIGHT -fill grey -pointsize 15 -gravity SouthWest -draw "text 10,5 '$TXT_COPYRIGHT'" $i $i; echo -n "."; done
echo ""


# Rtablissement des droits pour l'affichage au naviguateur
# (facultatif : dpend de votre configuration linux, mais cela est prconis dans les instructions PWG)
chmod -R 777 *

# Messages de fin
echo "Galerie $nom_gallery ajoute! - Merci d'avoir utilis Rep2Thumb 0.5!"
echo -n "Taille totale : "
du -h -s $CHEMIN_WEBGALLERY/$nom_gallery
echo " => Allez dans 'Synchroniser' pour l'ajouter  PhpWebGallery."

